/* create-patricia.c
 * Created: Nov. 13, 1998 by Daniel M. German (dmg@csg.uwaterloo.ca)
 * Revised: 
 * Copyright 1998 Daniel M. German (dmg@csg.uwaterloo.ca)
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id:  $
 * 
 */

#include <stdio.h>
#include <string.h>
#include <gdbm.h>

#include <stdlib.h>
#include "compjuga.h"

#define MAX_LINE  100


void main(void)
{
  char szLine[MAX_LINE];
  char *szPtr;
  char *szFamily;
  char *szOpt;
  datum VerbDatum,Key;
  GDBM_FILE dbf;
  verb_record VerbRecord;
  int iReturn;
  int i=0;


  /* Create database file */

  dbf  =  gdbm_open  ( "comjuga.dat", 512, GDBM_NEWDB, 0644, 0);

  /* read the fam file */

  /* THe format is verb{se}[options],<fam> */

  while (!feof(stdin))
    {
      i++;
      szFamily = NULL;
      szOpt = NULL;
      fgets(szLine, MAX_LINE, stdin);

      if (strlen(szLine) > 0)
	{
	  VerbRecord.iFamily = 0;

	  if ((szPtr = strchr(szLine, ',')) != NULL)
	    {
	      *szPtr  = 0;
	      szFamily=szPtr+1;
	      VerbRecord.iFamily = atoi(szFamily);
	    }
	  if ((szPtr = strchr(szLine, '[')) != NULL)
	    {
	      *szPtr  = 0;
	      szOpt=szPtr+1;
	    }


	  if (VerbRecord.iFamily > 0)
	    {
	      VerbDatum.dsize = sizeof(verb_record);
	      VerbDatum.dptr  = (char *)&VerbRecord;
	      Key.dsize = strlen(szLine)+1;
	      Key.dptr  = szLine;
	      iReturn = gdbm_store(dbf, Key, VerbDatum, GDBM_INSERT);
	      
	      if (i % 1000 == 0)
		printf("%s -> %d [%d]\n", szLine,VerbRecord.iFamily,iReturn);
	      
	      
	      if (iReturn != 0) {
		printf("%s[%s] -> %d [%d]\n", szLine,szOpt,VerbRecord.iFamily,iReturn);
		exit(1);
	      }
	    }
	}
    }
  gdbm_close(dbf);

}
