/* test-data-file.c
 *
 * Created: Nov. 13, 1998 by Daniel M. German (dmg@csg.uwaterloo.ca)
 * Revised: 
 * Copyright 1998 Daniel M. German (dmg@csg.uwaterloo.ca)
 *
 * This file is part of compjuga, a Spanish verbs conjugator 
 * (see http://csg.uwaterloo.ca/~dmg/compjuga
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: test-data-file.c,v 1.1 1998/11/18 20:43:33 dmg Exp $
 * 
 */

#include <stdio.h>

#include <string.h>
#include <gdbm.h>

#include <stdlib.h>

#include "compjuga.h"



void main(void)
{
  string szTemp;
  datum Key,nextkey,Record;
  int iNoItems,iOffset,i,iItemIndex;
  char *cPtr;
  GDBM_FILE dbf;
  dbf  =  gdbm_open  ( DATA_FILE, 512, GDBM_READER, 0, 0);

  Key = gdbm_firstkey ( dbf );
  while ( Key.dptr ) {
    nextkey = gdbm_nextkey ( dbf, Key );
    
    strncpy(szTemp, Key.dptr, Key.dsize);
    szTemp[Key.dsize] = 0;
    printf("%s->", szTemp);
    
    Record = gdbm_fetch(dbf,Key);
    if (Record.dptr == NULL)
      {
	printf("Error, record not found\n");
	exit(1);
      }
    iNoItems = (unsigned char)(*(Record.dptr+1));
    printf("Family: %d Number of Conjg %d\n",
	   (char)(*Record.dptr), iNoItems);
    
    cPtr = Record.dptr+2;
    for (i=0;i<iNoItems;i++)
      {
	iItemIndex = (unsigned char)*cPtr++;
	iOffset = (unsigned char)*cPtr++;
	strcpy(szTemp, cPtr);
	cPtr+=strlen(szTemp)+1;
	printf(" Item: [%d] [%d] %s", iItemIndex, iOffset, szTemp);
      }
    if (strlen(cPtr) > 0)
      printf("Options [%s]",cPtr);
    cPtr+=strlen(cPtr)+1;

    if (strlen(cPtr) > 0)
      printf("Note [%s]",cPtr);
    printf("\n");
    free(Record.dptr);
    free(Key.dptr);

    Key = nextkey;
  }
}
